/* GCC */

#define maxProduct 1000000
//    ,     ,    :
#define maxPlanets maxProduct //    
#define maxCompanies maxProduct //    

#include <stdio.h>
#include <queue>

using namespace std;

int n, m;
//   data     :     .
//            ,     
// ,          :
//  i   ,  j    (  ),  data[i][j] -
//   data[i * m + j] ( m   ).    
//  ,         .
//  ,     :  ,   
// ,   ,      .
bool data[maxProduct];
// planetVisited[k]    ,     0  
//   k;  -1,       (   k    ).
int planetVisited[maxPlanets];
// companyVisited[k]    ,         ,
//      k.
bool companyVisited[maxCompanies];

//  ,   ,   inline     
// (.   C++   ).

//      (    )    -
//      (.     ):
inline int getIndex(int planet, int company)
{
    return planet * m + company;
}

//    ,      planet    company:
inline void setInfo(int planet, int company, bool value)
{
    data[getIndex(planet, company)] = value;
}

//    ,    planet  company:
inline bool getInfo(int planet, int company)
{
    return data[getIndex(planet, company)];
}

int main()
{
    freopen("journey.in", "r", stdin);
    freopen("journey.out", "w", stdout);

    scanf("%d %d\n", &n, &m);
    //      :
    for (int planet = 0; planet < n; planet++)
    {
        for (int company = 0; company < m; company++)
        {
            char c;
            scanf("%c", &c);
            setInfo(planet, company, c == '1');
        }
        scanf("\n");
    }

    //           :
    for (int planet = 0; planet < n; planet++)
        planetVisited[planet] = -1;
    for (int company = 0; company < m; company++)
        companyVisited[company] = false;

    //      ,     (
    //       0,       ),  
    // ,    0        0 :
    queue<int> q;
    q.push(0);
    planetVisited[0] = 0;

    while (planetVisited[n - 1] == -1) //      
    {                                  //  ,  
        int currentPlanet = q.front(); //       (
        q.pop();                       //    )   
        for (int company = 0; company < m; company++)
            if (! companyVisited[company] && getInfo(currentPlanet, company))
            { //   ,         :
                companyVisited[company] = true; // ,    
                for (int planet = 0; planet < n; planet++)
                    if (planetVisited[planet] == -1 && getInfo(planet, company))
                    { //   ,        :
                        q.push(planet); //     
                        //            ,
                        //   ,          :
                        planetVisited[planet] = planetVisited[currentPlanet] + 1;
                    }
            }
    }

    // ³        :
    printf("%d\n", planetVisited[n - 1]);

    return 0;
}
